<?php

namespace Drupal\guifi\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Form\FormStateInterface;

/**
 * Form controller for the guifi entity edit forms.
 */
class GuifiForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   */

  protected function getNewRevisionDefault() {
    return TRUE;
  }

  public function save(array $form, FormStateInterface $form_state) {

    $entity = $this->getEntity();
    $entity->setNewRevision(TRUE);
    $result = $entity->save();
    $link = $entity->toLink($this->t('View'))->toRenderable();

    $message_arguments = ['%label' => $this->entity->label()];
    $logger_arguments = $message_arguments + ['link' => render($link)];

    if ($result == SAVED_NEW) {
      $this->messenger()->addStatus($this->t('New guifi %label has been created.', $message_arguments));
      $this->logger('guifi')->notice('Created new guifi %label', $logger_arguments);
    }
    else {
      $this->messenger()->addStatus($this->t('The guifi %label has been updated.', $message_arguments));
      $this->logger('guifi')->notice('Updated new guifi %label.', $logger_arguments);
    }

    $form_state->setRedirect('entity.guifi.canonical', ['guifi' => $entity->id()]);
  }

}
