<?php

namespace Drupal\guifi;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\user\EntityOwnerInterface;
use Drupal\Core\Entity\EntityChangedInterface;

/**
 * Provides an interface defining a guifi entity type.
 */
interface GuifiInterface extends ContentEntityInterface, EntityOwnerInterface, EntityChangedInterface {

  /**
   * Gets the guifi title.
   *
   * @return string
   *   Title of the guifi.
   */
  public function getTitle();

  /**
   * Gets the guifi type.
   *
   * @return string
   *   Type of the guifi.
   */
  public function getType();

  /**
   * Sets the guifi title.
   *
   * @param string $title
   *   The guifi title.
   *
   * @return \Drupal\guifi\GuifiInterface
   *   The called guifi entity.
   */
  public function setTitle($title);

  /**
   * Gets the guifi creation timestamp.
   *
   * @return int
   *   Creation timestamp of the guifi.
   */
  public function getCreatedTime();

  /**
   * Sets the guifi creation timestamp.
   *
   * @param int $timestamp
   *   The guifi creation timestamp.
   *
   * @return \Drupal\guifi\GuifiInterface
   *   The called guifi entity.
   */
  public function setCreatedTime($timestamp);

  /**
   * Returns the guifi status.
   *
   * @return bool
   *   TRUE if the guifi is enabled, FALSE otherwise.
   */
  public function isEnabled();

  /**
   * Sets the guifi status.
   *
   * @param bool $status
   *   TRUE to enable this guifi, FALSE to disable.
   *
   * @return \Drupal\guifi\GuifiInterface
   *   The called guifi entity.
   */
  public function setStatus($status);

}
