<?php

namespace Drupal\guifi\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;

/**
 * Plugin implementation of the 'guifi_email_labeled_table' formatter.
 *
 * @FieldFormatter(
 *   id = "guifi_email_labeled_table",
 *   label = @Translation("Table"),
 *   field_types = {"guifi_email_labeled"}
 * )
 */
class EmailLabeledTableFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {

    $header[] = '#';
    $header[] = $this->t('email');
    $header[] = $this->t('Label');

    $table = [
      '#type' => 'table',
      '#header' => $header,
    ];

    foreach ($items as $delta => $item) {
      $row = [];

      $row[]['#markup'] = $delta + 1;

      $row[]['#markup'] = $item->email;

      $row[]['#markup'] = $item->label;

      $table[$delta] = $row;
    }

    return [$table];
  }

}
