<?php

namespace Drupal\guifi\Plugin\Field\FieldFormatter;

use Drupal\Core\Datetime\DrupalDateTime;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;

/**
 * Plugin implementation of the 'guifi_sync_track_raw_text' formatter.
 *
 * @FieldFormatter(
 *   id = "guifi_sync_track_raw_tex",
 *   label = @Translation("text-raw"),
 *   field_types = {"guifi_sync_track"}
 * )
 */
class SyncTrackRawTextFormatter extends FormatterBase {


 public function viewElements(FieldItemListInterface $items, $langcode) {
    $element = []; 

    foreach ($items as $delta => $item) {

      if ($item->synctrack_source) {
        $element[$delta]['synctrack_source'] = [
          '#type' => 'json',
          '#title' => $this->t('Source'),
//	  '#prefix' => "{",
//          '#markup' => $item->synctrack_source."': ",
          '#markup' => $item->synctrack_source,
//	  '#suffix' => "|",
        ];
      }

      if ($item->synctrack_id) {
        $element[$delta]['synctrack_id'] = [
          '#type' => 'json',
          '#title' => $this->t('Id'),
	  '#prefix' => "|",
//          '#markup' => "id: ".$item->synctrack_id.",",
          '#markup' => $item->synctrack_id,
//	  '#suffix' => "|",
        ];
      }

      if ($item->synctrack_when) {
        $element[$delta]['synctrack_when'] = [
          '#type' => 'json',
          '#title' => $this->t('When'),
//	  '#suffix' => "}}",
	  '#prefix' => "|",
	  '#markup' => $item->synctrack_when,
        ];
      }
/*
      if ($item->synctrack_when) {
        $date = DrupalDateTime::createFromFormat('Y-m-d\TH:i:s', $item->synctrack_when);
        // @DCG: Consider injecting the date formatter service.
        // @codingStandardsIgnoreStart
        $date_formatter = \Drupal::service('date.formatter');
        // @codingStandardsIgnoreStart
        $timestamp = $date->getTimestamp();
        $formatted_date = $date_formatter->format($timestamp, 'long');
        $iso_date = $date_formatter->format($timestamp, 'custom', 'Y-m-d\TH:i:s') . 'Z';
        $element[$delta]['synctrack_when'] = [
          '#type' => 'json',
          '#title' => $this->t('Last sync'),
          'content' => [
            '#theme' => 'time',
            '#text' => $formatted_date,
            '#html' => FALSE,
            '#attributes' => [
              'datetime' => $iso_date,
            ],
            '#cache' => [
              'contexts' => [
                'timezone',
              ],
            ],
          ],
        ];
      }
 */

    }

    $element += array(
      '#type' => 'json',
      '#attributes' =>array('class' => array('container-block')),
		 '#prefix' => "[",
		 '#suffix' => "]",
    );



    return $element;
  }
}
