drop view if exists drops_contracts;  
create view drops_contracts as (
select 
	`guifi_field_data`.`title` AS `drop_title`,
	`guifi_field_data`.`id` AS `drop_id`,
	`comparea`.`name` AS `comparea_title`,
	`zone`.`name` AS `zone_title`,
	`provider`.`title` AS `provider_title`,
	`drop_contact_main`.`title` AS `maincontact_title`,
	`contract_customer`.`title` AS `customer_contact_title`,
	if ((trim(`customer_address`.`field_guificontact_address_organization`) = "") OR 
		`customer_address`.`field_guificontact_address_organization` IS NULL,
	 	concat(`customer_address`.`field_guificontact_address_family_name`,",  ",
		`customer_address`.`field_guificontact_address_given_name`),
       		`customer_address`.`field_guificontact_address_organization`)	
	AS `customer_name`,
	`drop_contract`.`title` AS `contract_title`,
	`contract_type`.`field_contract_type_value` AS `contract_type`,
	`location`.`title` AS `location_title`,
	/* `location_address`.`field_location_address_address_line1` AS `location_address`, */

	
	if(count(`fund_contact`.`title`)>0,count(`fund_contact`.`title`),NULL) AS `donations_count`,
	if(sum(`fund_amount`.`field_fund_amount_value`)>0,sum(`fund_amount`.`field_fund_amount_value`),NULL) AS `donations_amount`,
	str_to_date(max(`field_contract_activated_value`),"%Y-%m-%d") activated, 
	str_to_date(max(`field_contract_deactivated_value`),"%Y-%m-%d") deactivated,
    	datediff(
        	if(
			max(`field_contract_deactivated_value`) IS NULL, 
			sysdate(), 
			max(`field_contract_deactivated_value`)
		),
        	max(`field_contract_activated_value`)) days_active,

	/*min(`guifi_field_data`.`id`) AS `id_drop`,*/
	min(`drop_contact_main`.`id`) AS `id_contactmain`,
	min(`fund_contact`.`id`) AS `id_fundcontact`,
	min(`drop_contract`.`id`) AS `id_contract`,
	min(`provider`.`id`) AS `id_provider`,
	min(`location`.`nid`) AS `id_location`,
	min(`zone`.`tid`) AS `id_zone`,
	min(`comparea`.`tid`) AS `id_comparea` 

from (((((((((((((((((((((

	/* DROP CONTACT MAIN */
	`guifi_field_data` left join `guifi__field_drop_contact_main` 
		on(`guifi_field_data`.`id` = `guifi__field_drop_contact_main`.`entity_id` and `guifi__field_drop_contact_main`.`deleted` = '0')) 
	join `guifi_field_data` `drop_contact_main` 
		on(`guifi__field_drop_contact_main`.`field_drop_contact_main_target_id` = `drop_contact_main`.`id`)) 

	/* FUND CONTACT & AMOUNT */
	left join `guifi__field_fund_contact` `drop_contact_main__guifi__field_fund_contact` 
		on(`drop_contact_main`.`id` = `drop_contact_main__guifi__field_fund_contact`.`field_fund_contact_target_id` 
			and `drop_contact_main__guifi__field_fund_contact`.`deleted` = '0')) 
	left join `guifi_field_data` `fund_contact` 
		on(`drop_contact_main__guifi__field_fund_contact`.`entity_id` = `fund_contact`.`id`)) 
	left join `guifi__field_fund_amount` `fund_amount` 
		on(`fund_contact`.`id` = `fund_amount`.`entity_id` 
			and `fund_amount`.`deleted` = '0')) 

	/* CONTRACT */
	left join `guifi__field_drop_contract` 
		on(`guifi_field_data`.`id` = `guifi__field_drop_contract`.`entity_id` 
			and `guifi__field_drop_contract`.`deleted` = '0')) 
	join `guifi_field_data` `drop_contract` 
		on(`guifi__field_drop_contract`.`field_drop_contract_target_id` = `drop_contract`.`id`)) 
	left join `guifi__field_contract_activated` `activated` 
		on(`activated`.`entity_id` = `drop_contract`.`id`)) 
	left join `guifi__field_contract_deactivated` `deactivated` 
		on(`deactivated`.`entity_id` = `drop_contract`.`id`)) 
	left join `guifi__field_contract_customer` `customer` 
		on(`customer`.`entity_id` = `drop_contract`.`id`)) 
	left join `guifi__field_guificontact_address` `customer_address` 
		on(`customer_address`.`entity_id` = `customer`.`field_contract_customer_target_id`)) 
	left join `guifi__field_contract_type` `contract_type` 
		on(`contract_type`.`entity_id` = `drop_contract`.`id`)) 
	left join `guifi_field_data` `contract_customer` 
		on(`customer`.`field_contract_customer_target_id` = `contract_customer`.`id` ))

	/* PROVIDER */
	left join `guifi__field_contract_provider` `drop_contract__guifi__field_contract_provider` 
		on(`drop_contract`.`id` = `drop_contract__guifi__field_contract_provider`.`entity_id` 
			and `drop_contract__guifi__field_contract_provider`.`deleted` = '0')) 
	join `guifi_field_data` `provider` 
		on(`drop_contract__guifi__field_contract_provider`.`field_contract_provider_target_id` = `provider`.`id`)) 

	/* LOCATION */
	left join `guifi__field_drop_location` 
		on(`guifi_field_data`.`id` = `guifi__field_drop_location`.`entity_id` 
			and `guifi__field_drop_location`.`deleted` = '0')) 
	join `node_field_data` `location` 
		on(`guifi__field_drop_location`.`field_drop_location_target_id` = `location`.`nid`)) 
	/*
	join `node__field_location_address` `location_address` 
		on(`location_address`.`entity_id` = `location`.`nid`)) 
	*/

	/* ZONE */
	left join `node__field_location_zone` `location__node__field_location_zone` 
		on(`location`.`nid` = `location__node__field_location_zone`.`entity_id` 
		and `location__node__field_location_zone`.`deleted` = '0')) 
	join `taxonomy_term_field_data` `zone` 
		on(`location__node__field_location_zone`.`field_location_zone_target_id` = `zone`.`tid`)) 

	/* COMP AREA */
	join `taxonomy_term__field_comp_zone` `zone__taxonomy_term__field_comp_zone` 
		on(`zone`.`tid` = `zone__taxonomy_term__field_comp_zone`.`field_comp_zone_target_id` 
			and `zone__taxonomy_term__field_comp_zone`.`deleted` = '0')) 
	join `taxonomy_term_field_data` `comparea` 
		on(`zone__taxonomy_term__field_comp_zone`.`entity_id` = `comparea`.`tid`)) 


where `guifi_field_data`.`bundle` = 'guifi_drops' 

group by 
	1,2,3,4,5,6,7,8,9,10,11
	/*
	`guifi_field_data`.`title`,
	`comparea`.`name`,
	`zone`.`name`,
	`provider`.`title`,
	`drop_contact_main`.`title`,
	`drop_contract`.`title`,
	`location`.`title`
	*/
);

